Lucene++ - a full-featured, c++ search engine
API Documentation

Public Member Functions | Static Public Member Functions | Data Fields | Protected Member Functions | Protected Attributes
Lucene::CachingSpanFilter Class Reference

Wraps another SpanFilter's result and caches it. The purpose is to allow filters to simply filter, and then wrap with this class to add caching. More...

`#include <CachingSpanFilter.h>`

Inheritance diagram for Lucene::CachingSpanFilter:

## Public Member Functions

| CachingSpanFilter (const SpanFilterPtr &filter, CachingWrapperFilter::DeletesMode deletesMode=CachingWrapperFilter::DELETES_RECACHE)
| New deletions always result in a cache miss, by default (CachingWrapperFilter#RECACHE. More...
virtual | ~CachingSpanFilter ()
virtual String | getClassName ()
boost::shared_ptr< CachingSpanFilter > | shared_from_this ()
virtual DocIdSetPtr | getDocIdSet (const IndexReaderPtr &reader)
| Creates a DocIdSet enumerating the documents that should be permitted in search results. More...
virtual SpanFilterResultPtr | bitSpans (const IndexReaderPtr &reader)
| Returns a SpanFilterResult with true for documents which should be permitted in search results, and false for those that should not and Spans for where the true docs match. More...
virtual String | toString ()
| Returns a string representation of the object. More...
virtual bool | equals (const LuceneObjectPtr &other)
| Return whether two objects are equal. More...
virtual int32_t | hashCode ()
| Return hash code for this object. More...
Public Member Functions inherited from Lucene::SpanFilter
virtual | ~SpanFilter ()
boost::shared_ptr< SpanFilter > | shared_from_this ()
Public Member Functions inherited from Lucene::Filter
virtual | ~Filter ()
boost::shared_ptr< Filter > | shared_from_this ()
Public Member Functions inherited from Lucene::LuceneObject
virtual | ~LuceneObject ()
virtual void | initialize ()
| Called directly after instantiation to create objects that depend on this object being fully constructed. More...
virtual LuceneObjectPtr | clone (const LuceneObjectPtr &other=LuceneObjectPtr())
| Return clone of this object. More...
virtual int32_t | compareTo (const LuceneObjectPtr &other)
| Compare two objects. More...
Public Member Functions inherited from Lucene::LuceneSync
virtual | ~LuceneSync ()
virtual SynchronizePtr | getSync ()
| Return this object synchronize lock. More...
virtual LuceneSignalPtr | getSignal ()
| Return this object signal. More...
virtual void | lock (int32_t timeout=0)
| Lock this object using an optional timeout. More...
virtual void | unlock ()
| Unlock this object. More...
virtual bool | holdsLock ()
| Returns true if this object is currently locked by current thread. More...
virtual void | wait (int32_t timeout=0)
| Wait for signal using an optional timeout. More...
virtual void | notifyAll ()
| Notify all threads waiting for signal. More...

## Static Public Member Functions

static String | _getClassName ()
Static Public Member Functions inherited from Lucene::SpanFilter
static String | _getClassName ()
Static Public Member Functions inherited from Lucene::Filter
static String | _getClassName ()

## Data Fields

int32_t | hitCount
int32_t | missCount

## Protected Member Functions

SpanFilterResultPtr | getCachedResult (const IndexReaderPtr &reader)
Protected Member Functions inherited from Lucene::LuceneObject
| LuceneObject ()

## Protected Attributes

SpanFilterPtr | filter
FilterCachePtr | cache
Protected Attributes inherited from Lucene::LuceneSync
SynchronizePtr | objectLock
LuceneSignalPtr | objectSignal

## Detailed Description

Wraps another SpanFilter's result and caches it. The purpose is to allow filters to simply filter, and then wrap with this class to add caching.

## Constructor & Destructor Documentation

## ◆ CachingSpanFilter()

Lucene::CachingSpanFilter::CachingSpanFilter | ( | const SpanFilterPtr & | filter,
|  | CachingWrapperFilter::DeletesMode | deletesMode = `CachingWrapperFilter::DELETES_RECACHE`
| ) |  |

New deletions always result in a cache miss, by default (CachingWrapperFilter#RECACHE.

## ◆ ~CachingSpanFilter()

virtual Lucene::CachingSpanFilter::~CachingSpanFilter | ( |  | ) |

virtual

## Member Function Documentation

## ◆ _getClassName()

static String Lucene::CachingSpanFilter::_getClassName | ( |  | ) |

inline static

## ◆ bitSpans()

virtual SpanFilterResultPtr Lucene::CachingSpanFilter::bitSpans | ( | const IndexReaderPtr & | reader | ) |

virtual

Returns a SpanFilterResult with true for documents which should be permitted in search results, and false for those that should not and Spans for where the true docs match.

Parameters

  reader | The IndexReader to load position and DocIdSet information from

Returns
  A SpanFilterResult

Implements Lucene::SpanFilter.

## ◆ equals()

virtual bool Lucene::CachingSpanFilter::equals | ( | const LuceneObjectPtr & | other | ) |

virtual

Return whether two objects are equal.

Reimplemented from Lucene::LuceneObject.

## ◆ getCachedResult()

SpanFilterResultPtr Lucene::CachingSpanFilter::getCachedResult | ( | const IndexReaderPtr & | reader | ) |

protected

## ◆ getClassName()

virtual String Lucene::CachingSpanFilter::getClassName | ( |  | ) |

inline virtual

Reimplemented from Lucene::SpanFilter.

## ◆ getDocIdSet()

virtual DocIdSetPtr Lucene::CachingSpanFilter::getDocIdSet | ( | const IndexReaderPtr & | reader | ) |

virtual

Creates a DocIdSet enumerating the documents that should be permitted in search results.

Note: null can be returned if no documents are accepted by this Filter.

Note: This method will be called once per segment in the index during searching. The returned DocIdSet must refer to document IDs for that segment, not for the top-level reader.

Parameters

  reader | a IndexReader instance opened on the index currently searched on. Note, it is likely that the provided reader does not represent the whole underlying index ie. if the index has more than one segment the given reader only represents a single segment.

Returns
  a DocIdSet that provides the documents which should be permitted or prohibited in search results. NOTE: null can be returned if no documents will be accepted by this Filter.

See also
  DocIdBitSet

Implements Lucene::Filter.

## ◆ hashCode()

virtual int32_t Lucene::CachingSpanFilter::hashCode | ( |  | ) |

virtual

Return hash code for this object.

Reimplemented from Lucene::LuceneObject.

## ◆ shared_from_this()

boost::shared_ptr< CachingSpanFilter > Lucene::CachingSpanFilter::shared_from_this | ( |  | ) |

inline

## ◆ toString()

virtual String Lucene::CachingSpanFilter::toString | ( |  | ) |

virtual

Returns a string representation of the object.

Reimplemented from Lucene::LuceneObject.

## Field Documentation

## ◆ cache

FilterCachePtr Lucene::CachingSpanFilter::cache

protected

## ◆ filter

SpanFilterPtr Lucene::CachingSpanFilter::filter

protected

## ◆ hitCount

int32_t Lucene::CachingSpanFilter::hitCount

## ◆ missCount

int32_t Lucene::CachingSpanFilter::missCount

The documentation for this class was generated from the following file:

- CachingSpanFilter.h

clucene.sourceforge.net